local M = {}

local constant = require 'constant'
local vector = require 'vector'
local util = require 'util'

function M.cons(go, m, obj, objs)
   local _art = world:atlas_entry(constant.ATLAS, 'crate')
   local sprite = go:add_component('CStaticSprite', {entry=_art})
   go:add_component('CCollidable', {fixture={type='rect',
                                             w=_art.w,
                                             h=_art.h,
                                             density=1.0}})
   go:fixed_rotation(0)
   go:body_type(constant.DYNAMIC)

   local drag = function(go, comp)
      while true do
         coroutine.yield()
         local vel = vector.new(go:vel())
         local stop_impulse = vel * -go:mass()
         go:apply_impulse(stop_impulse * 0.07)

         local dadt = go:angle_rate();
         local stop_angimp = dadt * -go:inertia()
         go:apply_angular_impulse(stop_angimp * 0.05)

         -- keep angle in sync
         sprite:angle(go:angle())
      end
   end
   go:add_component('CScripted', {update_thread=util.thread(drag)})
end

return M
